﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDockManagerTesting
{
    public class WsModel: INotifyPropertyChanged
    {
        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion

        public WsModel()
        {
            DataSource = new ObservableCollection<ParameterRecord>();
            IsInit = true;

            

        }

        public bool IsInit { get; set; }

        public string Header { get; set; }

        private bool _update;
        public bool Update
        {
            get
            {
                return _update;
            }
            set
            {
                _update = value;
                NotifyPropertyChanged("Update");
            }
        }

        public object[] SelectedItems { get; set; }

        private ObservableCollection<ParameterRecord> _dataSource;
        public ObservableCollection<ParameterRecord> DataSource
        {
            get
            {
                return _dataSource;
            }
            protected set
            {
                _dataSource = value;
                NotifyPropertyChanged("DataSource");
            }
        }

        public class ParameterRecord
        {
            public ParameterRecord(int id)
            {
                Id = id;

                ParameterValues = new Dictionary<string, ParameterValue>();
            }

            public int Id { get; set; }

            public string Key { get; set; }

            public Dictionary<string, ParameterValue> ParameterValues { get; set; }

            public class ParameterValue
            {
                public ParameterValue(string id, object value)
                {
                    Id = id;
                    Value = value;
                }

                public string Id { get; set; }

                public object Value { get; set; }
            }
        }
    }
}
